# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from magneto_api_client.models.type import Type
from typing import Optional, Set
from typing_extensions import Self

class JsonSchema(BaseModel):
    """
    Base class for models that exclude unset fields.  **Note**: This overrides any `exclude_unset` kwarg passed for the model and its nested models.
    """ # noqa: E501
    type: Optional[Type] = None
    title: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    format: Optional[StrictStr] = None
    properties: Optional[Dict[str, JsonSchema]] = None
    items: Optional[JsonSchema] = None
    icon: Optional[StrictStr] = None
    enum_colors: Optional[Dict[str, StrictStr]] = Field(default=None, alias="enumColors")
    enum_icons: Optional[Dict[str, StrictStr]] = Field(default=None, alias="enumIcons")
    enum: Optional[List[Any]] = None
    additional_properties: Optional[StrictBool] = Field(default=None, alias="additionalProperties")
    read_only: Optional[StrictBool] = Field(default=None, alias="readOnly")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["type", "title", "description", "format", "properties", "items", "icon", "enumColors", "enumIcons", "enum", "additionalProperties", "readOnly"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JsonSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in properties (dict)
        _field_dict = {}
        if self.properties:
            for _key_properties in self.properties:
                if self.properties[_key_properties]:
                    _field_dict[_key_properties] = self.properties[_key_properties].to_dict()
            _dict['properties'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of items
        if self.items:
            _dict['items'] = self.items.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JsonSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": Type.from_dict(obj["type"]) if obj.get("type") is not None else None,
            "title": obj.get("title"),
            "description": obj.get("description"),
            "format": obj.get("format"),
            "properties": dict(
                (_k, JsonSchema.from_dict(_v))
                for _k, _v in obj["properties"].items()
            )
            if obj.get("properties") is not None
            else None,
            "items": JsonSchema.from_dict(obj["items"]) if obj.get("items") is not None else None,
            "icon": obj.get("icon"),
            "enumColors": obj.get("enumColors"),
            "enumIcons": obj.get("enumIcons"),
            "enum": obj.get("enum"),
            "additionalProperties": obj.get("additionalProperties"),
            "readOnly": obj.get("readOnly")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

# TODO: Rewrite to not use raise_errors
JsonSchema.model_rebuild(raise_errors=False)

